# Sisense Widgets Tabber 

**Supported Sisense Version**: 6.7+

## Description

Add the ability to avoid overcrowded dashboards, with many different charts and widgets,
to place several very similar widgets, one next to another, and display only selected ones.

## Installation

1. Download the plugin
2. Extract the `.zip` file to `C:\Program Files\Sisense\PrismWeb\Plugins`
    - If the folder does not exist, please create it before extracting the `.zip` file.
3. Configure the include *config.js* file (read more below)
4. Refresh your dashboard

## Implementation

1) Create a Tabber custom widget
2) Edit a tabber widget script, configure the different tabs:

    ```javascript
        widget.tabs = [{
                title: "Tab1", 
                displayWidgetIds : ["556c26f88a6b1c68290000f8"], 
                hideWidgetIds : ["556eb860106eb3f42100002f"]
            },
            {
                title: "Tab2", 
                displayWidgetIds : ["556eb860106eb3f42100002f"], 
                hideWidgetIds : ["556c26f88a6b1c68290000f8"]
            }];
     ```

3) In case you like to change default configuration as described bellow edit the widget script: widget.on('render',function(w,e){});
setting e to the configuration you'd like to change.
 
    ```javascript
        widget.on('render',function(w, e){e.selectedColor = 'red';});
     ```

4) Change `Show title in view mode` parameter to configure to show the widget title in 'view mode'.
Set `true` to show the widget title in view mode.
The parameter not affect on PDF preview and downloaded PDF.
Parameter located at `Design` panel in widget edit mode.

## Limitation:

1) The plugin affects dashboard widgets layout. As a result Sisense native drag and drop functionality may work unexpectedly in some specific cases:
   - dragging the tabber widget on the dashboard,
   - dragging the widgets between tabs and in/out the tabs.
2) In case of multiple widgets in one row that is affected by a the 'tabber' widget, all the visible widgets will be equally spread in a row.
   - The horizontal widget resize functionality in this row is forbidden.